from os import listdir
from string import rfind
from gtk import ListStore , icon_theme_get_default

class desktop_files():
	#~ builds a list of desktop files
	def __init__(self):
		ls = listdir('/usr/share/applications')
		list_of_desktop_files = []
		self.dict= {}
		for i in ls: 
			if i[-8:] == '.desktop':
				list_of_desktop_files.append(i)
				
		self.iconset = icon_theme_get_default()
		self.desktop_files_data = ListStore(str,str,str,str)
		
		for file in sorted(list_of_desktop_files):
			icon_name = self.get_icon_name_in_desktop_file(file)
			comm_name = self.get_comm_name_in_desktop_file(file)
			appl_name = self.get_appl_name_in_desktop_file(file)
			description = self.get_description_in_desktop_file(file)
			if icon_name and comm_name and appl_name:
				self.desktop_files_data.append([appl_name,icon_name,comm_name,description])
			
			icon_name = self.get_icon_name_in_desktop_file_v2(file)
			self.dict[comm_name] = icon_name

	def get_icon_name_in_desktop_file(self,desktop_file):
		try:
			file = open('/usr/share/applications/%s'%desktop_file)
		except:
			return ''
		lines = list(file)
		file.close()
		for line in lines:
			if line.startswith('Icon'):
				#if it is a file name
				if '/' in line:
					icon_name = line[line.rfind('/')+1:-5]
				else:
					if '.png' in line or '.svg' in line or '.xpm' in line:
						icon_name = line[5:-5] 
					else: 
						icon_name =  line[5:-1]
				if self.iconset.has_icon(icon_name):
					return icon_name
				else:
					command = self.get_comm_name_in_desktop_file(desktop_file)
					if self.iconset.has_icon(command):
						return command
		return ''
				


	def get_icon_name_in_desktop_file_v2(self,desktop_file):
		try:
			file = open('/usr/share/applications/%s'%desktop_file)
		except:
			return ''
		lines = list(file)
		file.close()
		for line in lines:
			if line.startswith('Icon'):
				if ('.png' in line or '.svg' in line or '.xpm' in line) and ('/' not in line):
					icon_name = line[5:-5] 
				else: 
					icon_name =  line[5:-1]
				return icon_name
		return ''
	



	def get_appl_name_in_desktop_file(self,desktop_file):
		try:
			file = open('/usr/share/applications/%s'%desktop_file)
		except:
			return ''
		lines = list(file)
		file.close()
		for line in lines:
			if line.startswith('Name[en') or line.startswith('Name=') :
				return line.split('=')[1][0:-1]
		return ''
				
	def get_description_in_desktop_file(self,desktop_file):
		try:
			file = open('/usr/share/applications/%s'%desktop_file)
		except:
			return ''
		lines = list(file)
		file.close()
		for line in lines:
			if line.startswith('Comment[en'):
				return line.split('=')[1] 
		return ''

	def get_comm_name_in_desktop_file(self, desktop_file):
		try:
			file = open('/usr/share/applications/%s'%desktop_file)
		except:
			return ''
		lines = list(file)
		file.close()
		for line in lines:
			if line.startswith('Exec'):
				comm = line[5:].split('%')[0]
				if comm[0]=='/':
					return comm[comm.rfind('/')+1:-1]
				else:
					return comm[:-1]
		return ''

	def from_command_get_icon_name(self,comm):
		#~ print "sto cercando = ", comm
		if comm in self.dict:
			return self.dict[comm]
		else:
			return ''
			
	def list_comm_icon_pairs(self):
		for i,j in self.dict.iteritems():
			print i
			print j
			print "*******************"

	def get_dictionary_of_dfiles(self):
		return self.dict
		
	def get_liststore_of_desktop_files(self):
		return self.desktop_files_data
