import os
import string
import re

def find_path_matches(text):
	#default exit 
	matches = []; code = 'ok'; matches_number = len(matches)
	#~ print "1text=",text
	#the following code does like white spaces in filenames, so we remove the escape characters
	stext = re.sub(r'(\\ )',r' ',text)
	text = text.replace('\\','')
	#print "text=",text
	#we cut this text in two parts at the rightmost "/" and we have the parent directory
	parent_dir = text[0:text.rfind('/')+1]
	#and file_match_prefix is the text used to find matches in the files in parent directory
	file_match_prefix = text[text.rfind('/'):]
	
	#print "parent_dir",parent_dir
	#print 'file_match_prefix = ',file_match_prefix 
	#print 
	#we find all files and directories in parent_directory, if we can, of course
	if os.access(parent_dir,os.F_OK): #existence
		if os.access(parent_dir,os.R_OK):#read permission
			file_and_dirs_completion_list = os.listdir(parent_dir)
		else:
			code = 'accessdenied'
			return [] , code, -1
	else:
		code = 'notfound'
		return [] , code, matches_number
	
	file_and_dirs_completion_list  = sort_path(file_and_dirs_completion_list, parent_dir)

	#at this point we find the files and dirs in parent_directory that starts with file_match_prefix
	for file in file_and_dirs_completion_list:
		#for consistency we add a / at the beginning
		file = '/'+file
		#if file in parent_dir starts with file_match_prefix
		if file.startswith(file_match_prefix):
			#if it is a directory we append a slash
			if os.path.isdir(parent_dir+file[1:]):
				file = file + '/'
			#then we add it to the matches list completing 
			matches.append((parent_dir+file[1:]).replace(' ','\\ '))
			
	#print "matches = ", matches
	code = 'ok'
	matches_number = len(matches)

	##last = [matches[-1]]
	#last.extend(matches[0:-1]) 
	#print matches

	return matches, code , matches_number
	
	
	
	
def find_comm_matches(text,prog_list):
	#~ print "here i have this = ", text
	matches = []
	for program in prog_list:
		if program.startswith(text):
			matches.append(program)
	matches.sort()
	#~ print matches
	if matches:
		code = 'ok'
		matches_number = len(matches)
	else:
		code = 'notfound'
		matches_number = 0

	return matches, code , matches_number
	
	
def find_text_tobe_completed(text,curs_pos):
	#this one returns the text from the 
	#cursor position to the first true blank space
	#at the left of the cursor
	#~ print "text_given = ", text
	text_to_the_left_ofthe_cursor = text[0:curs_pos]
	#~ print "text_to_the_left_ofthe_cursor", text_to_the_left_ofthe_cursor
	a_white_space= re.search(r" (?!\\)", text_to_the_left_ofthe_cursor[::-1])
	if a_white_space:
		index_of_the_white_space = curs_pos - a_white_space.end() + 1 
	else:
		index_of_the_white_space = 0
	#~ print "tobecompleted =", text[index_of_the_white_space:curs_pos]
	return text[index_of_the_white_space:curs_pos]


def sort_path(list,parent_dir):
	visible_dirs = []
	visible_files = []
	invisible_dirs = []
	invisible_files = []
	
	for file in list:
		#print "pd =", parent_dir+file
		if os.path.isdir(parent_dir+file):
			if is_visible(file):
				visible_dirs.append(file)
			else:
				invisible_dirs.append(file)

		else:
			if is_visible(file):
				visible_files.append(file)
			else:
				invisible_files.append(file)			
				
	
	matches = sorted(visible_dirs)+sorted(visible_files)+sorted(invisible_dirs)+sorted(invisible_files)
	return matches
	
	
def is_visible(file):
	#print file
	if file[0] == '.':
	  return False
	else:
	  return True


	
	
	
	
	
	
	
	
